/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2005 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: bw.h,v 1.11 2005/03/16 19:27:41 jura Exp $ */

#ifdef HAVE_BW

struct dsUlist;
struct entry;
typedef struct BWinfo BWinfo;
typedef struct BWdata BWdata;
typedef struct bwUlist bwUlist;

//this is per ds
#define BW_HASH_SIZE   0x4000
#define BW_HASH_MASK   (BW_HASH_SIZE-1)
#define BW_HASH(ptr)   ((unsigned)ptr>>4)&BW_HASH_MASK

class BWEngine {
	public:

		//BWData
		unsigned bwd_used;
		unsigned bwd_total;
		BWdata *bwdReady;	
		
		//bwUlist 
		unsigned bwu_used;
		unsigned bwu_total;
		bwUlist *bwuReady;

		BWdata **table;
		
		BWEngine();
		~BWEngine();

		void AddBW2entry(BWinfo *bwi, entry *e, match mf, void *key);
		void FreeBWentry(entry *e);
};

typedef struct BWdata {
	void *key;
	
	unsigned long limit_in;
	unsigned long limit_out;

	unsigned num_flows;
		
	unsigned long end_t[2];
	unsigned long total_bytes[2];
	
	BWdata* next;

	//probably need to add reference to object from where we get *BWinfo
} BWdata;

typedef struct bwUlist {
	match mf; //this necessary do detect flow derection for connected unit
	bwUlist *next;
	BWdata *bwd;
} bwUlist;

u_char BWCheck(entry *e, u_long size, struct timeval *tv);

#endif
/////////////////////////////////////////////////////////////////////////////////////////
typedef struct BWinfo {
	unsigned long in;
	unsigned long out;
} BWinfo;

BWinfo* setBW(BWinfo* bwi, char **param, u_char *i);
char* getBW(BWinfo *bwi, char *buf);
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
