/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2005 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: html.c,v 1.55.2.10 2006/04/16 08:46:08 jura Exp $ */

#include "netams.h"

char mon_name[][12]={ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
//////////////////////////////////////////////////////////////////////////////////////////
//this bad because refers to hidden variables *file and full_path[]
#define HTML_PUSHD(path)	{ file=&path[strlen(path)]; sprintf(file, "/"); file++;}
#define HTML_POPD()		{ file=prefix; }

void cShowBillingHtml(Html_cfg *cfg, Connection *conn);
void cShowBillingAccountsHtml(Html_cfg *cfg, Connection *conn, struct tm *tm);

Connection *sHOpenFile(Connection *conn, char *fullname);
int sHSafeMkdir(char *temp);
void sHPrintHeader(Connection *conn, char *title, char *back, char *logopath=NULL);
void sPrintFooter(Connection *conn, char *back);
void sHPrintUnits(Html_cfg *cfg, FILE *f);
void sHPrintUnitsRoot(Html_cfg *cfg, FILE *f, NetUnit *p);
void sHPrintUnitsTree(Html_cfg *cfg, FILE *f, NetUnit *p, u_char isadmintool=0);
void sHPrintUnitST(FILE *f, NetUnit *p);
void sHPrintTHeader(FILE *f);
void sHPrintTHeaderTopData(FILE *f, char* period);
void sHPrintTHeaderTopItem(FILE *f, html_top_item *item);
void sHPrintTHeaderPreincluded(FILE *f);
void HtmlCalendarY(FILE *f, char *path, char *file, struct tm *tm, const char *yhref, const char *mhref);
void HtmlCalendarM(FILE *f, char *path, char *file, struct tm *tm, const char *href);
void HtmlCalendarD(FILE *f, char *path, char *file, struct tm *tm, const char *href);

void HtmlRedirect(char *path, char *href);
//////////////////////////////////////////////////////////////////////////////////////////
void sHtmlAction(Html_cfg *cfg){
	if (!cfg->path) { aLog(D_INFO, "cannot create pages because no html dir is set!\n"); return; }
	
	//prepare connection
	Connection *conn = cfg->conn;

	NetUnit *u=NULL;

	char *param[64]; for (int i=0; i<64; i++) param[i]=empty;
	struct stat sb;
	bzero(&sb, sizeof (struct stat));

	//=================================================================================
	u_char len=strlen(cfg->path);
	char path[512];  		// better change then to dynamic allocation with len [len+256];
	// we have trick here 
	// actually cfg->path is presetted - so we can store it permanently and work only via offset 
	// pointed by *file
	strncpy(path, cfg->path, len);
	char *prefix=&path[len];	//prefix from cfg->path to actual filename
	char *file;			//from here filename will be printed
	
	char tmp[256];

	struct tm tm;
	// first, calculate current year, month, day and hour
	{
		time_t current=time(NULL);
		localtime_r(&current, &tm);
	}
	
	//create path
	snprintf(prefix, 255, "/%04d/%02d/%02d/%02d", tm.tm_year+1900, tm.tm_mon+1, tm.tm_mday, tm.tm_hour);
	if (sHSafeMkdir(path)) return;
	HTML_PUSHD(path);
	
	aDebug(DEBUG_HTML, "Creation main data in %s\n", path);

	//=================================================================================
	// if this is the end of hour, generate hourly report
	snprintf(file, 255, "time.html");
	conn=sHOpenFile(conn, path); if (!conn) return;
	snprintf(tmp, 255, Locale(LC_H_TRAFINFO), tm.tm_mday, tm.tm_mon+1, tm.tm_year+1900, tm.tm_hour, tm.tm_mday, tm.tm_mon+1, tm.tm_year+1900, tm.tm_hour+1);
	sHPrintHeader(conn, tmp, "index.html");
	fprintf(conn->stream_w, "<div style=\"margin-left : 5%%; align: right;\">\n");
	sHPrintUnits(cfg, conn->stream_w);
	fprintf(conn->stream_w, "</div> \n");
	sPrintFooter(conn, "index.html");

	//=================================================================================
	// create index file
	snprintf(file, 255, "index.html");
	conn=sHOpenFile(conn, path); if (!conn) return;
	sHPrintHeader(conn, Locale(LC_H_RUNTIME), "../../../../index.html");

	fprintf(conn->stream_w, "<h3>%s %02d %s</h3>\n \
		<div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_TIMEDERIVED), tm.tm_mday, mon_name[tm.tm_mon]);
	
	// year table
	HtmlCalendarY(conn->stream_w, path, file, &tm, "../../../../%04d", "../../../../%04d/%02d/index.html");
	
	// month table
	HtmlCalendarM(conn->stream_w, path, file, &tm, "../../%02d/index.html");

	// day table
	HtmlCalendarD(conn->stream_w, path, file, &tm, "../%02d/time.html");

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	fprintf(conn->stream_w, "<h3>%s</h3>\n \
		<div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_OBJSTAT));
	
	netams_rwlock_rdlock(&Units->rwlock);
	if (cfg->cpages==CPAGES_ALL || cfg->cpages==CPAGES_GROUPS || cfg->cpages==CPAGES_GROUPLIST) {
		fprintf(conn->stream_w, "<b>%s:</b><br>\n", Locale(LC_H_GROUPS));
		for (u=Units->root; u!=NULL && u->type==NETUNIT_GROUP; u=u->next) {
			if (!u->name) continue;
			int k=0;
			if (cfg->cpages==CPAGES_GROUPLIST)
				for (Html_grouplist_item *item=cfg->grouproot; item!=NULL; item=item->next)
					if (item->groupid==u->id) k=1;

			if ((cfg->cpages==CPAGES_GROUPLIST && k) || cfg->cpages!=CPAGES_GROUPLIST)
				fprintf(conn->stream_w, "<a href=\"../../../../clients/%s/index.html\">%s</a>\n", u->name, u->name);
		}
	}

	if (cfg->cpages==CPAGES_ALL || cfg->cpages==CPAGES_GROUPLIST) {
		fprintf(conn->stream_w, "<br><b>%s:</b><br>\n", Locale(LC_H_UNITS));
		for (; u!=NULL; u=u->next) {
			//that's ok because groups are in the beginning
			if (!u->name) continue;
			int k=0;
			if (cfg->cpages==CPAGES_GROUPLIST && u->parent)
				for (Html_grouplist_item *item=cfg->grouproot; item!=NULL; item=item->next)
					if (item->groupid==u->parent->id) k=1;
				
			if ((cfg->cpages==CPAGES_GROUPLIST && k) || cfg->cpages!=CPAGES_GROUPLIST)
				fprintf(conn->stream_w, "<a href=\"../../../../clients/%s/index.html\">%s</a>\n", u->name, u->name);
		}
	}
	netams_rwlock_unlock(&Units->rwlock);

	fprintf(conn->stream_w, "<br><br></div>\n");

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	if (cfg->display_health){
		fprintf(conn->stream_w, "<h3>%s</h3>\n<div style=\"margin-left : 5%%; \">\n", Locale(LC_H_SYSTAT));
		if (cShowSystemHealth(conn, 1)) fprintf(conn->stream_w, "<br><font color=red><b>%s</b></font>", Locale(LC_H_SYSTAT_WRONG));
		fprintf(conn->stream_w, "</div>\n");
	}

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	if (cfg->display_top){
		fprintf(conn->stream_w, "<h3>%s</h3>\n<div style=\"margin-left : 5%%; \">\n", Locale(LC_H_TOPUSERS));
		fprintf(conn->stream_w, "%u %s \n</div>\n", cfg->display_top, Locale(LC_H_TOPUSERS_STR));
	}

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	fprintf(conn->stream_w, "<h3>%s</h3>\n \
		<div style=\"margin-left : 5%%;\"> \n\
		%s <a href=\"software-version.html\">show version</a><br> \n", Locale(LC_H_SERVICES), Locale(LC_H_SERV_OUTPUTOF));
	if(Quota) fprintf(conn->stream_w, "%s <a href=\"software-quota.html\">%s</a><br> \n", Locale(LC_H_SERV_STATE), Locale(LC_H_SERV_QUOTA));
 	if(Login) fprintf(conn->stream_w, "%s <a href=\"software-login.html\">%s</a><br> \n", Locale(LC_H_SERV_STATE), Locale(LC_H_SERV_LOGIN));
	fprintf(conn->stream_w,	"%s <a href=\"software-config.html\">show config</a><br>", Locale(LC_H_SERV_OUTPUTOF));
#ifdef HAVE_BILLING
	if(Billing) fprintf(conn->stream_w, "%s <a href=\"software-billing.html\">%s</a><br>\n", Locale(LC_H_SERV_STATE), Locale(LC_H_SERV_BILLING));
#endif
	fprintf(conn->stream_w, "</div>\n");
	sPrintFooter(conn, NULL);

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// create SW version
	snprintf(file, 255, "software-version.html");
	conn=sHOpenFile(conn, path); if (!conn) return;
	sHPrintHeader(conn, Locale(LC_H_SW_VERSION), "index.html");
	fprintf(conn->stream_w, "<pre>\n");
	cShowVersion(conn);
	fprintf(conn->stream_w, "</pre>\n");
	sPrintFooter(conn, "index.html");

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// create Quota state
	if(Quota) {
		snprintf(file, 255, "software-quota.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		snprintf(tmp, 255, "%s %s", Locale(LC_H_SERV_STATE), Locale(LC_H_SERV_QUOTA));
		sHPrintHeader(conn, tmp, "index.html");
		fprintf(conn->stream_w, "<pre>\n");
		cShowQuota(conn, param);
		fprintf(conn->stream_w, "</pre>\n");
		sPrintFooter(conn, "index.html");
	}
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// create Login state
	if(Login) {
		snprintf(file, 255, "software-login.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		snprintf(tmp, 255, "%s %s", Locale(LC_H_SERV_STATE), Locale(LC_H_SERV_LOGIN));
		sHPrintHeader(conn, tmp, "index.html");
		fprintf(conn->stream_w, "<pre>\n");
		cShowLogin(conn, param);
		fprintf(conn->stream_w, "</pre>\n");
		sPrintFooter(conn, "index.html");
	}
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// create SW log
	snprintf(file, 255, "software-config.html");
	conn=sHOpenFile(conn, path); if (!conn) return;
	sHPrintHeader(conn, Locale(LC_H_RUNNING_CONFIG), "index.html");
	fprintf(conn->stream_w, "<pre>\n");
	cShowConfig(NULL, conn, 1);
	fprintf(conn->stream_w, "</pre>\n");
	sPrintFooter(conn, "index.html");

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// create TOP pages
	if (cfg->display_top){
		html_top_item* table_h = (html_top_item*)aMalloc(cfg->display_top*(sizeof (struct html_top_item)));
		html_top_item* table_d = (html_top_item*)aMalloc(cfg->display_top*(sizeof (struct html_top_item)));
		html_top_item* table_w = (html_top_item*)aMalloc(cfg->display_top*(sizeof (struct html_top_item)));
		html_top_item* table_m = (html_top_item*)aMalloc(cfg->display_top*(sizeof (struct html_top_item)));

		// find top units
		Units->tries_lock++;
		int err=netams_rwlock_tryrdlock(&Units->rwlock);
		if (err==EBUSY) { Units->tries_lock_failed++; netams_rwlock_rdlock(&Units->rwlock); }
		NetUnit *u; policy_data *cpd;
		struct pstat s_h; Policy *p_h; 
		struct pstat s_d; Policy *p_d; 
		struct pstat s_w; Policy *p_w; 
		struct pstat s_m; Policy *p_m; 
		html_top_item *item;
		
		for (u=Units->root; u!=NULL; u=u->next) {
			if (u->name == NULL || u->ap==NULL) continue;
			switch (u->type) {
				case NETUNIT_HOST: 
				case NETUNIT_USER:
					// find sum and policy where counters are MAX
					bzero(&s_h, sizeof (struct pstat)); p_h=NULL;
					bzero(&s_d, sizeof (struct pstat)); p_d=NULL; 
					bzero(&s_w, sizeof (struct pstat)); p_w=NULL;
					bzero(&s_m, sizeof (struct pstat)); p_m=NULL;
					for (cpd=u->ap->root; cpd!=NULL; cpd=cpd->next) {
						if (cpd->h.in+cpd->h.out >= s_h.in+s_h.out) { memcpy(&s_h, &cpd->h, sizeof (struct pstat)); p_h=cpd->policy; }
						if (cpd->d.in+cpd->d.out >= s_d.in+s_d.out) { memcpy(&s_d, &cpd->d, sizeof (struct pstat)); p_d=cpd->policy; }
						if (cpd->w.in+cpd->w.out >= s_w.in+s_w.out) { memcpy(&s_w, &cpd->w, sizeof (struct pstat)); p_w=cpd->policy; }
						if (cpd->m.in+cpd->m.out >= s_m.in+s_m.out) { memcpy(&s_m, &cpd->m, sizeof (struct pstat)); p_m=cpd->policy; }
					}
					// put the data somewhere onto the table
					for (int i=0; i<cfg->display_top; i++) { item=&table_h[i]; if (item->s.in+item->s.out<=s_h.in+s_h.out) { memmove(&table_h[i+1], &table_h[i], sizeof (struct html_top_item)*(cfg->display_top-i-1)); item->u=u; item->p=p_h; memcpy(&item->s, &s_h, sizeof (struct pstat)); break; } }
					for (int i=0; i<cfg->display_top; i++) { item=&table_d[i]; if (item->s.in+item->s.out<=s_d.in+s_d.out) { memmove(&table_d[i+1], &table_d[i], sizeof (struct html_top_item)*(cfg->display_top-i-1)); item->u=u; item->p=p_d; memcpy(&item->s, &s_d, sizeof (struct pstat)); break; } }
					for (int i=0; i<cfg->display_top; i++) { item=&table_w[i]; if (item->s.in+item->s.out<=s_w.in+s_w.out) { memmove(&table_w[i+1], &table_w[i], sizeof (struct html_top_item)*(cfg->display_top-i-1)); item->u=u; item->p=p_w; memcpy(&item->s, &s_w, sizeof (struct pstat)); break; } }
					for (int i=0; i<cfg->display_top; i++) { item=&table_m[i]; if (item->s.in+item->s.out<=s_m.in+s_m.out) { memmove(&table_m[i+1], &table_m[i], sizeof (struct html_top_item)*(cfg->display_top-i-1)); item->u=u; item->p=p_m; memcpy(&item->s, &s_m, sizeof (struct pstat)); break; } }
					break;
				default:
					break;
			}
		} 
		if (err!=EDEADLK) netams_rwlock_unlock(&Units->rwlock);

		// create top pages
		snprintf(file, 255, "top.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		snprintf(tmp, 255, "%s %s %s", Locale(LC_H_TOPUSERS), Locale(LC_H_CURRENT), Locale(LC_H_CHOUR));
		sHPrintHeader(conn, tmp, "index.html");
		sHPrintTHeaderTopData(conn->stream_w, Locale(LC_H_CHOUR));
		for (int i=0; i<cfg->display_top; i++) { item=&table_h[i]; sHPrintTHeaderTopItem(conn->stream_w, item); }
		fprintf(conn->stream_w, "</table><br>\n");	sPrintFooter(conn, "index.html");
	
		snprintf(file, 255, "../top.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		snprintf(tmp, 255, "%s %s %s", Locale(LC_H_TOPUSERS), Locale(LC_H_CURRENT), Locale(LC_H_CDAY));
		sHPrintHeader(conn, tmp, "index.html", "../../..");
		sHPrintTHeaderTopData(conn->stream_w, Locale(LC_H_CDAY));
		for (int i=0; i<cfg->display_top; i++) { item=&table_d[i]; sHPrintTHeaderTopItem(conn->stream_w, item); }
		fprintf(conn->stream_w, "</table><br>\n");	sPrintFooter(conn, "index.html");
		
		snprintf(file, 255, "../top-week.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		snprintf(tmp, 255, "%s %s %s", Locale(LC_H_TOPUSERS), Locale(LC_H_CURRENT2), Locale(LC_H_CWEEK2));
		sHPrintHeader(conn, tmp, "index.html", "../../..");
		sHPrintTHeaderTopData(conn->stream_w, Locale(LC_H_CWEEK));
		for (int i=0; i<cfg->display_top; i++) { item=&table_w[i]; sHPrintTHeaderTopItem(conn->stream_w, item); }
		fprintf(conn->stream_w, "</table><br>\n");	sPrintFooter(conn, "index.html");
		
		snprintf(file, 255, "../../top.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		snprintf(tmp, 255, "%s %s %s", Locale(LC_H_TOPUSERS), Locale(LC_H_CURRENT), Locale(LC_H_CMONTH));
		sHPrintHeader(conn, tmp, "index.html", "../../..");
		sHPrintTHeaderTopData(conn->stream_w, Locale(LC_H_CMONTH));
		for (int i=0; i<cfg->display_top; i++) { item=&table_m[i]; sHPrintTHeaderTopItem(conn->stream_w, item); }
		fprintf(conn->stream_w, "</table><br>\n");	sPrintFooter(conn, "index.html");

		aFree(table_h); aFree(table_d); aFree(table_w); aFree(table_m);
	}

	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifdef HAVE_BILLING
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	// create billing log
	if(Billing) {
		snprintf(file, 255, "software-billing.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		snprintf(tmp, 255, "%s %s", Locale(LC_H_SERV_STATE), Locale(LC_H_SERV_BILLING));
		sHPrintHeader(conn, tmp, "index.html");
		cShowBillingHtml(cfg, conn);
		sPrintFooter(conn, "index.html");
		if (cfg->apages==APAGES_ALL) cShowBillingAccountsHtml(cfg, conn, &tm);
	}
#endif
	HTML_POPD(); 

	//=================================================================================
	// generate month index page
	snprintf(prefix, 255, "/%04d/%02d", tm.tm_year+1900, tm.tm_mon+1);
	HTML_PUSHD(path);

	snprintf(file, 255, "index.html");
	conn=sHOpenFile(conn, path); if (!conn) return;
	sHPrintHeader(conn, Locale(LC_H_RUNTIME), "../../index.html", "../..");

	fprintf(conn->stream_w, "<h3>%s: %s</h3>\n <div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_INDEX_MONTH), mon_name[tm.tm_mon]);
	
	// year table
	HtmlCalendarY(conn->stream_w, path, file, &tm, "../../%04d", "../../%04d/%02d/index.html");

	// month table
	file[0]=0;
	HtmlCalendarM(conn->stream_w, path, file, &tm, "%02d/index.html");
	
	fprintf(conn->stream_w, "<br></div><br>\n");
	sPrintFooter(conn, "../../index.html");
	
	//change file and cleanup
	HTML_POPD();

	//=================================================================================
	// create a master index file at path root, pointing to the current file
	snprintf(file, 255, "/index.html");
	snprintf(tmp, 255, "%04d/%02d/%02d/%02d/index.html", tm.tm_year+1900, tm.tm_mon+1, tm.tm_mday, tm.tm_hour);
	HtmlRedirect(path, tmp);

	//=================================================================================
	// generate day index redirect page
	snprintf(file, 255, "/%04d/%02d/%02d/index.html", tm.tm_year+1900, tm.tm_mon+1, tm.tm_mday);
	snprintf(tmp, 255, "%02d/index.html", tm.tm_hour);
	HtmlRedirect(path, tmp);
	//=================================================================================

	if (cfg->cpages == CPAGES_NONE) goto ACCESS; //skip clients

	//=================================================================================
	// generate per-client pages
	aDebug(DEBUG_HTML, "Generate clients pages\n");

	netams_rwlock_rdlock(&Units->rwlock);
	for (u=Units->root; u!=NULL; u=u->next) {
		if (u->name == NULL) continue;

		if (!(cfg->cpages==CPAGES_ALL || cfg->cpages==CPAGES_GROUPLIST ||
			(cfg->cpages==CPAGES_GROUPS && u->type==NETUNIT_GROUP))) continue;	 // CPAGES_CHECK

		if (cfg->cpages==CPAGES_GROUPLIST) {
			if (!u->parent && u->type!=NETUNIT_GROUP) continue;
			if (u->type==NETUNIT_GROUP) {
				int k=0;
				for (Html_grouplist_item *item=cfg->grouproot; item!=NULL; item=item->next)
					if (item->groupid==u->id) k=1;
				
				if (k==0) continue; // skip this group as it is not belongs to group listed in GROUPLIST			
			}
			if (u->parent && u->type!=NETUNIT_GROUP) {
				int k=0;
				for (Html_grouplist_item *item=cfg->grouproot; item!=NULL; item=item->next)
					if (item->groupid==u->parent->id) k=1;
				
				if (k==0) continue; // skip this unit as it is not belongs to group listed in GROUPLIST			
			}
		}

		//create path
		snprintf(prefix, 255, "/clients/%s/%04d/%02d", u->name, tm.tm_year+1900, tm.tm_mon+1);
		if (sHSafeMkdir(path)) return;
		HTML_PUSHD(path);
		aDebug(DEBUG_HTML, "Creation client %s pages in %s\n", u->name, path);


		snprintf(file, 255, "index-day-%02d.html", tm.tm_mday);
		conn=sHOpenFile(conn, path); if (!conn) return;
		sHPrintHeader(conn, Locale(LC_H_TRAFINFO_SELECTED), "javascript:history.go(-2)");

		switch (u->type) {
			case NETUNIT_HOST: {
				NetUnit_host *h;
				h = (NetUnit_host*)u;
				inet_ntop(AF_INET, &(h->ip), tmp, 32);
				fprintf(conn->stream_w, "HOST: <b>%s</b><br>OID: <b>%06X</b><br> IP: <b>%-12s</b><br>\n", h->name, h->id, tmp);
				if (u->parent && u->parent->name)
					fprintf(conn->stream_w, "PARENT: <b><a href=\"../../../%s/index.html\">%10s</a></b><br>\n", u->parent->name, u->parent->name);
				break;
			}
			case NETUNIT_USER: {
				NetUnit_user *h;
				h = (NetUnit_user*)u;
				inet_ntop(AF_INET, &(h->ip), tmp, 32);
				fprintf(conn->stream_w, "USER: <b>%s</b><br>OID: <b>%06X</b><br> IP: <b>%-12s</b><br>\n", h->name, h->id, tmp);
				if (u->parent && u->parent->name)
					fprintf(conn->stream_w, "PARENT: <b><a href=\"../../../%s/index.html\">%10s</a></b><br>\n", u->parent->name, u->parent->name);
				break;
			}
			case NETUNIT_CLUSTER: {
				NetUnit_cluster *h;
				NetUnit_net *t;
				h = (NetUnit_cluster*)u;
				fprintf(conn->stream_w, "CLUSTER: <b>%s</b><br>OID: <b>%06X</b><br>IPs:<b>\n", h->name, h->id);
				for (t=h->root; t!=NULL; t=t->next) {
					inet_ntop(AF_INET, &(t->ip), tmp, 32);
					fprintf(conn->stream_w, "%s/%u ", tmp, MASK2MLEN(t->mask));
				}
				fprintf(conn->stream_w, "</b><br>\n");
				if (u->parent && u->parent->name)
					fprintf(conn->stream_w, "PARENT: <b><a href=\"../../../%s/index.html\">%10s</a></b><br>\n", u->parent->name, u->parent->name);
				break;
			}
			case NETUNIT_GROUP: {
				NetUnit_group *h;
				h = (NetUnit_group*)u;
				
				fprintf(conn->stream_w, "GROUP: <b>%s</b><br>OID: <b>%06X</b><br>Subs: <b>", h->name, h->id);
				for (NetUnit *t=h->child_root; t!=NULL; t=t->group_next) {
					if (!t->name) continue;
					if (cfg->cpages==CPAGES_ALL || cfg->cpages==CPAGES_GROUPLIST)
						fprintf(conn->stream_w, "<a href=\"../../../%s/index.html\">%s</a> ", t->name, t->name);
					else
						fprintf(conn->stream_w, "%s ", t->name);
				}
				fprintf(conn->stream_w, "</b><br>\n");
				if (u->parent && u->parent->name)
					fprintf(conn->stream_w, "PARENT: <b><a href=\"../../../%s/index.html\">%10s</a></b><br>\n", u->parent->name, u->parent->name);
				 break;
			}
			case NETUNIT_NET: {
				NetUnit_net *h;
				h = (NetUnit_net*)u;
				inet_ntop(AF_INET, &(h->ip), tmp, 32);
				fprintf(conn->stream_w, "NET: <b>%s</b><br>OID: <b>%06X</b><br>NETWORK: <b>%s</b>\n", h->name, h->id, tmp);
				inet_ntop(AF_INET, &(h->mask), tmp, 32);
				fprintf(conn->stream_w, " NET_MASK: <b>%s</b><br>\n", tmp);
				if (u->parent && u->parent->name)
					fprintf(conn->stream_w, "PARENT: <b><a href=\"../../../%s/index.html\">%10s</a></b><br>\n", u->parent->name, u->parent->name);
				break;
			}
			default:
				fprintf(conn->stream_w, "&lt;UNKNOWN&gt;<br> OID: <b>%06X</b>\n", u->id);
				break;
		}
		if (u->description) fprintf(conn->stream_w, "DESCRIPTION: <b>%s</b><br>\n", u->description);

		//++++++++++++++++++++++++++++++++++++++++++
		// year/month table (client)
		fprintf(conn->stream_w, "<br><b>%s:</b><br>", Locale(LC_H_CALENDAR));
		HtmlCalendarY(conn->stream_w, path, file, &tm, "../../%04d", "../../%04d/%02d/index.html");

		// month table (client)
		HtmlCalendarM(conn->stream_w, path, file, &tm, "index-day-%02d.html");
		//+++++++++++++++++++++++++++++++++++++++++

		fprintf(conn->stream_w, "<h3>%s %s, %s</h3>\n <div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_TRAFINFO_FOR), u->name, Locale(LC_H_TRAFINFO_ACTUAL));

		if (u->type!=NETUNIT_GROUP) sHPrintTHeader(conn->stream_w);
		sHPrintUnitsTree(cfg, conn->stream_w, u);
		if (u->type!=NETUNIT_GROUP) fprintf(conn->stream_w, "</table><br>\n");

		if (cfg->is_rrd && u->ap) {
			policy_data *cpd; Policy *p;
			bzero(tmp, 255);
			netams_rwlock_rdlock(&u->ap->rwlock);
			for (cpd=u->ap->root; cpd!=NULL; cpd=cpd->next) {
				p = cpd->policy;
				sprintf(tmp+strlen(tmp), "%06X,%s,", p->id, p->name);
			}
			netams_rwlock_unlock(&u->ap->rwlock);

			//fprintf(conn->stream_w, "<img src=\"../../../../admin/rrdgraph.cgi?oid=%06X&period=month&policy=%s\"><br>", u->id, tmp); 
		}
		fprintf(conn->stream_w, "</div><br>");

		sPrintFooter(conn, "javascript:history.go(-2)");
		
		// generate month index page
		snprintf(file, 255, "index.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		sHPrintHeader(conn, Locale(LC_H_RUNTIME), "../../index.html");

		fprintf(conn->stream_w, "<h3>%s: %s</h3>\n <div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_INDEX_MONTH), mon_name[tm.tm_mon]);

		// month table
		HtmlCalendarM(conn->stream_w, path, file, &tm, "index-day-%02d.html");

		fprintf(conn->stream_w, "<br></div><br>\n");
		sPrintFooter(conn, "../../index.html");
		
		//cleanup and  restore *file
		HTML_POPD();

		// create a master index file at client root, pointing to the current file
                snprintf(file, 255, "/clients/%s/index.html", u->name);
                snprintf(tmp, 255, "%04d/%02d/index-day-%02d.html", tm.tm_year+1900, tm.tm_mon+1, tm.tm_mday);
                HtmlRedirect(path, tmp);

		if (cfg->is_htaccess && u->flags&NETUNIT_CHANGED) {
			if (u->password) {
				snprintf(file, 255, "/clients/%s/.htaccess", u->name);
				conn=sHOpenFile(conn, path); if (!conn) return;
				fprintf(conn->stream_w, "AuthName \"NeTAMS User Login\"\n Require user");
				Users->listUsersHtml(conn);
				if (cfg->is_htaccess==2) fprintf(conn->stream_w, " %s\n<FilesMatch \"\\.(gif|jpe?g|png)$\">\nRequire valid-user\nSatisfy Any\n</FilesMatch>\nAuthType Basic\n\n", u->name);
				else if (cfg->is_htaccess==1) fprintf(conn->stream_w, " %s\n<FilesMatch \"\\.(gif|jpe?g|png)$\">\nRequire valid-user\nSatisfy Any\n</FilesMatch>\nAuthType Basic\nAuthUserFile %s/.htpasswd\n\n", u->name, cfg->path);
				u->flags&=~NETUNIT_CHANGED;
			}
		}
	} // 'for' loop, all clients
	netams_rwlock_unlock(&Units->rwlock);

ACCESS:

	//=================================================================================
	// if htaccess==1 AND UserList changed flag is set, generate new .htaccess and .htpasswd
	if (cfg->is_htaccess) {
		if (Users->changed_user) {
			snprintf(file, 255, "/.htaccess");
			conn=sHOpenFile(conn, path); if (!conn) return;
			fprintf(conn->stream_w, "AuthName \"NeTAMS Administrators Only\"\n Require user");
			Users->listUsersHtml(conn);
			if (cfg->is_htaccess==2) fprintf(conn->stream_w, "\n<FilesMatch \"\\.(gif|jpe?g|png)$\">\nRequire valid-user\nSatisfy Any\n</FilesMatch>\nAuthType Basic\n\n");
			else if (cfg->is_htaccess==1) fprintf(conn->stream_w, "\n<FilesMatch \"\\.(gif|jpe?g|png)$\">\nRequire valid-user\nSatisfy Any\n</FilesMatch>\nAuthType Basic\nAuthUserFile %s/.htpasswd\n\n", cfg->path);
			Users->changed_user=0;
		}

		if (cfg->is_rrd) fprintf(conn->stream_w, "Options +FollowSymLinks\n");

		if (cfg->is_htaccess==1 && Users->changed_pw) {
			snprintf(file, 255, "/.htpasswd");
			conn=sHOpenFile(conn, path); if (!conn) return;
			Users->listPasswordsHtml(conn);
			Units->listPasswordsHtml(conn);
		} 
	}
	//=================================================================================
	//clear connection
	if(conn->stream_w) { fclose(conn->stream_w); conn->stream_w=NULL; }
}
//////////////////////////////////////////////////////////////////////////////////////////
Connection *sHOpenFile(Connection *conn, char *name){
	int f;
	
	if(conn->stream_w) { fclose(conn->stream_w); conn->stream_w=NULL; }

	f=open(name, O_RDWR|O_CREAT|O_TRUNC, 0644);
	if(f==-1) {
		aLog(D_ERR, "Can't create file %s : %s\n", name, strerror(errno));
		return NULL;
	}
	aDebug(DEBUG_HTML, "%s : %s\n", name, (f+1)?"ok":"fail");
	conn->stream_w=fdopen(f, "w");
	return conn;
}
//////////////////////////////////////////////////////////////////////////////////////////
int sHSafeMkdir(char *temp){  // this equal to  mkdir -p 
	struct stat sb;
	bzero(&sb, sizeof (struct stat));
	
	int i=stat(temp, &sb);
	if (!(sb.st_mode & S_IFDIR) || i) {
		i=mkdir(temp, 0711);
		if (i) {
			i=(strrchr(temp, '/')-temp);
			if(i>0) {
				char *prefix=(char*)aMalloc(i+1);
				strncpy(prefix, temp, i);     //find prefix
	
				i=sHSafeMkdir(prefix);		//recurse
				aFree(prefix);
			
				if(i) return -1;		//if error on previous level no need to continue

				i=mkdir(temp, 0711);		//there is no error, retry to create
			} else  i=-1;	//ensure this is error

			if(i) {
				aLog(D_INFO, "failed to create %s: %s \n", temp, strerror(errno));
				return -1;
			}
		}
		aDebug(DEBUG_HTML, "make directory %s\n", temp);
	} else if (!(sb.st_mode & S_IFDIR)) {
		aLog(D_INFO, "failed to create %s, file already exist and not directory\n", temp);
		return -1;
	}
	return 0;
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintHeader(Connection *conn, char *title, char *back, char *logopath){

	fprintf(conn->stream_w, "<html><head><title>NeTAMS - %s</title><META http-equiv=\"Pragma\" content=\"no-cache\"><META http-equiv=\"Expires\" content=\"-1\"><META http-equiv=\"Cache-Control\" content=\"no-cache\"><META http-equiv=\"Content-type\" content=\"text/html; charset=%s\">\n</HEAD> \n\
		<body bgcolor=white marginheight=0 leftmargin=0 topmargin=0 marginwidth=0> \n\
		<table width=100%% align=left border=0 cellpadding=5 cellspacing=0> \n\
		<tr bgcolor='white' align=left><td width=376> \n\
		<A href=\"http://www.netams.com/index.html\"> \n\
		<img src=\"%s/images/logo_sm.jpg\" width=376 height=60 border=0></a></td> \n\
		<td valign=middle align=left width=80%%> %s	<a href=\"http://www.netams.com/index.html\"><b>NeTAMS</b></a><br> \
		<b>%s: </b>", title, language_charset_str[lang], logopath?logopath:"../../../..", Locale(LC_H_REPORT), Locale(LC_H_SW_VERSION));
	fprintf(conn->stream_w, "%d.%d.%d (build %d", aaa_fw_major_version, aaa_fw_minor_version, aaa_fw_subversion, aaa_fw_build_version);
	if (aaa_fw_build_version_local) fprintf(conn->stream_w, ".%d", aaa_fw_build_version_local);
	fprintf(conn->stream_w, ")<br>\n");

	char buff[32];
	fprintf(conn->stream_w, "<b>%s:</b> %s<br> </td></tr> <tr bgcolor='#ccccff'><td colspan=2> \n\
		<h3>%s", Locale(LC_H_CR_TIME), timeU2T(time(NULL), buff), title);
	if (back) fprintf(conn->stream_w, "<font face=monospace size=-1><b> [<a href=\"%s\"> <- %s</a> ]</b></font>", back, Locale(LC_H_BACK));
	fprintf(conn->stream_w, "</h3></td></tr><tr><td colspan=2>\n");
}
//////////////////////////////////////////////////////////////////////////////////////////
void sPrintFooter(Connection *conn, char *back){
	fprintf(conn->stream_w, "</td></tr>\n");
	if (back) fprintf(conn->stream_w, "<tr bgcolor='#ccccff'><td colspan=2><font face=monospace size=-1><b>[<a href=\"%s\"> <- %s</a> ]</b></font></td></tr>", back, Locale(LC_H_BACK));
	fprintf(conn->stream_w, "</table>\n</body></html> \n");
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintUnits(Html_cfg *cfg, FILE *f){

	Units->tries_lock++;
	int err=netams_rwlock_tryrdlock(&Units->rwlock);
	if (err==EBUSY) { Units->tries_lock_failed++; netams_rwlock_rdlock(&Units->rwlock); }

	NetUnit *u;

	//print groups with childs
	for (u=Units->root; u!=NULL && u->type==NETUNIT_GROUP ; u=u->next)
		if(u->parent==NULL) sHPrintUnitsTree(cfg, f, u, 1);

	sHPrintTHeader(f);
	
	//print left units
	for(; u!=NULL; u=u->next) 
		 if(u->parent==NULL) sHPrintUnitsTree(cfg, f, u, 1);
	
	fprintf(f, "</table><br>\n");

	if (err!=EDEADLK) netams_rwlock_unlock(&Units->rwlock);
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintUnitsRoot(Html_cfg *cfg, FILE *f, NetUnit *p){
	NetUnit *u;
	NetUnit_group *gr = (NetUnit_group*)p;

	for (u=gr->child_root; u!=NULL && u->type==NETUNIT_GROUP; u=u->group_next)
		sHPrintUnitsTree(cfg, f, u, 1);

	sHPrintTHeader(f);
	
	for (; u!=NULL; u=u->group_next)
		sHPrintUnitsTree(cfg, f, u, 1);
    
	fprintf(f, "</table><br>\n");
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintUnitsTree(Html_cfg *cfg, FILE *f, NetUnit *u, u_char isadmintool){
	char buffer[32];
	unsigned is_zero_counters=1;
	policy_data *cpd;
	
	if (u->type==NETUNIT_GROUP) {
		sHPrintTHeader(f);
		fprintf(f, "<tr bgcolor='#000000'><td colspan=11 height=2> </td></tr><tr bgcolor='#ffffcc'><td colspan=11>GROUP: <b>%s</b> <font size=-1>oid %06X</font>", u->name?u->name:"", u->id);
		fprintf(f, "</td></tr>\n");
		sHPrintUnitST(f, u);
		fprintf(f, "<tr bgcolor='#ccffcc'><td colspan=11 align=right>\n");

		sHPrintUnitsRoot(cfg, f, u);

		fprintf(f, "</td></tr>\n");
		fprintf(f, "</table><br>\n");
    	} else {
		fprintf(f, "<tr bgcolor='#ffffcc'><td colspan=11>");
		if (isadmintool) fprintf(f, "<A href=\"../../../../admintool.cgi?oid=%06X\"><img src=\"../../../../images/admintool-logo.gif\" width=20 height=20 border=1 align=absmiddle></a> ", u->id);
		//if (isadmintool || cfg->is_rrd) fprintf(f, "<A href=\"../../../../admin/rrdgraph.cgi?oid=%06X\"><img src=\"../../../../images/rrdgraph-logo.gif\" width=20 height=20 border=1 align=absmiddle></a> ", u->id);

		if (u->type==NETUNIT_HOST) fprintf(f, "HOST");
		else if (u->type==NETUNIT_USER) fprintf(f, "USER");
		else if (u->type==NETUNIT_NET) fprintf(f, "NET");
		else fprintf(f, "CLUSTER");
		fprintf(f, " <b>%s</b> <font size=-1>oid %06X</font>", u->name?u->name:"", u->id);

		if (u->type==NETUNIT_HOST)
			fprintf(f, " IP: <i>%-12s</i>", inet_ntop(AF_INET, &(((NetUnit_host*)u)->ip), buffer, 32));
		else if (u->type==NETUNIT_USER) 
			fprintf(f, " IP: <i>%-12s</i>", inet_ntop(AF_INET, &(((NetUnit_user*)u)->ip), buffer, 32));
		else if (u->type==NETUNIT_NET) {
			fprintf(f, " IP: <i>%-12s</i>", inet_ntop(AF_INET, &(((NetUnit_net*)u)->ip), buffer, 32));
			fprintf(f, " MASK: <i>%-12s</i>", inet_ntop(AF_INET, &(((NetUnit_net*)u)->mask), buffer, 32));
		}
		if (isadmintool && cfg && u->ap && cfg->servlet_url) { 
			policy_data *cpd;
			char *p=NULL;  
			time_t now=time(NULL);
			
			netams_rwlock_rdlock(&u->ap->rwlock);
			for (cpd=u->ap->root; cpd!=NULL; cpd=cpd->next)
				print_to_string(&p, "%d:", cpd->policy->id);
			netams_rwlock_unlock(&u->ap->rwlock);

			if (p) fprintf(f, "&nbsp;<A href=\"%s/NetamsView/netams?action=table&unit_oid=%d&policies_oids=%s&time_from=%ld000&time_to=%ld000&timespan=M\"><img src=\"../../../../images/showtable-logo.gif\" width=20 height=20 border=1 align=absmiddle></a>", cfg->servlet_url, u->id, p, now, now);
			aFree(p);
		}
		
		if (u->description) fprintf(f, "&nbsp;&nbsp;&nbsp;<font color=navy>%s</font>", u->description);
		
		if (u->ap) {
			netams_rwlock_rdlock(&u->ap->rwlock);
			for (cpd=u->ap->root; cpd!=NULL; cpd=cpd->next) 
				if (cpd->h.in!=0 || cpd->h.out!=0 ||
					cpd->d.in!=0 || cpd->d.out!=0 ||
					cpd->w.in!=0 || cpd->w.out!=0 ||
					cpd->m.in!=0 || cpd->m.out!=0)	is_zero_counters=0;
			netams_rwlock_unlock(&u->ap->rwlock);
		}

		if (is_zero_counters) fprintf(f, "&nbsp;&nbsp;&nbsp;<font color=navy>(%s)</font>", Locale(LC_H_ALL_ZERO));
  		fprintf(f, "</td></tr>\n\n");
		if (!is_zero_counters) sHPrintUnitST(f, u);
	}
		
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintUnitST(FILE *f, NetUnit *u){
	if(!u->ap) return; //nothing to do
	policy_data *cpd;
	static char b2qt[8][32];

	netams_rwlock_rdlock(&u->ap->rwlock);
	for (cpd=u->ap->root; cpd!=NULL; cpd=cpd->next) {
		fprintf(f, "<tr align=right><td valign=middle bgcolor='#ffffaa'>%s</td>\n", cpd->policy->name?cpd->policy->name:"<\?\?>");
		fprintf(f, "<td>%10s</td><td>%10s</td>", bytesQ2T(cpd->h.in, b2qt[0]), bytesQ2T(cpd->h.out, b2qt[1]));
		fprintf(f, "<td>%10s</td><td>%10s</td>", bytesQ2T(cpd->d.in, b2qt[2]), bytesQ2T(cpd->d.out, b2qt[3]));
		fprintf(f, "<td>%10s</td><td>%10s</td>", bytesQ2T(cpd->w.in, b2qt[4]), bytesQ2T(cpd->w.out, b2qt[5]));
		fprintf(f, "<td>%10s</td><td>%10s</td></tr>\n", bytesQ2T(cpd->m.in, b2qt[6]), bytesQ2T(cpd->m.out, b2qt[7]));
	}
	netams_rwlock_unlock(&u->ap->rwlock);
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintTHeader(FILE *f){

	fprintf(f, "<table cellpadding=3 cellspacing=0 border=1 width=95%% bgcolor=white>\n");
	fprintf(f, "<tr bgcolor=navy align=center><td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		</tr><tr bgcolor=black align=center> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		</tr>\n", Locale(LC_H_ACCT_POLICY), Locale(LC_H_CHOUR), Locale(LC_H_CDAY), Locale(LC_H_CWEEK), Locale(LC_H_CMONTH),
		Locale(LC_H_IN), Locale(LC_H_OUT), Locale(LC_H_IN), Locale(LC_H_OUT), Locale(LC_H_IN), Locale(LC_H_OUT), Locale(LC_H_IN), Locale(LC_H_OUT));
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintTHeaderTopData(FILE *f, char *period){

	fprintf(f, "<table cellpadding=3 cellspacing=0 border=1 width=95%% bgcolor=white>\n");
	fprintf(f, "<tr bgcolor=navy align=center><td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		</tr><tr bgcolor=black align=center> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		</tr>\n", Locale(LC_H_TYPE), Locale(LC_H_NAME), Locale(LC_H_DESCR), Locale(LC_H_IP), Locale(LC_H_POLICY), period, Locale(LC_H_IN), Locale(LC_H_OUT));
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintTHeaderTopItem(FILE *f, html_top_item *item){
	char *unit_type; static char b2qt[2][32];
	static char buffer[32];
	
	if (item->u!=NULL && item->p!=NULL) {
		if (item->u->type==NETUNIT_HOST) { 
			unit_type="HOST"; 
			inet_ntop(AF_INET, &(((NetUnit_host*)item->u)->ip), buffer, 32);
		} else {
			unit_type="USER"; 
			inet_ntop(AF_INET, &(((NetUnit_user*)item->u)->ip), buffer, 32);
		}
		fprintf(f, "<tr align=right><td>%s</td><td bgcolor='#ffffcc'><b>%s</b></td><td align=left>%s</td><td>%s</td><td bgcolor='#ffffaa'>%s</td><td>%10s</td><td>%10s</td></tr>\n",
			unit_type, item->u->name?item->u->name:"<\?\?>", item->u->description?item->u->description:"&nbsp", buffer, item->p->name, bytesQ2T(item->s.in, b2qt[0]), bytesQ2T(item->s.out, b2qt[1]));
	}
}
//////////////////////////////////////////////////////////////////////////////////////////
void sHPrintTHeaderPreincluded(FILE *f){

	fprintf(f, "<table cellpadding=3 cellspacing=0 border=1 width=95%% bgcolor=white>\n");
	fprintf(f, "<tr bgcolor=navy align=center><td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td><td rowspan=2 valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td colspan=2><font face=monospace size=-1 color=yellow>%s</font></td> \
		</tr><tr bgcolor=black align=center> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		<td><font color=white size=-1>%s</font></td><td><font color=white size=-1>%s</font></td> \
		</tr>\n", Locale(LC_H_SUBPLAN_ID), Locale(LC_H_ACCT_POLICY), Locale(LC_H_CHOUR), Locale(LC_H_CDAY), Locale(LC_H_CWEEK), Locale(LC_H_CMONTH),
		Locale(LC_H_IN), Locale(LC_H_OUT), Locale(LC_H_IN), Locale(LC_H_OUT), Locale(LC_H_IN), Locale(LC_H_OUT), Locale(LC_H_IN), Locale(LC_H_OUT));
}
//////////////////////////////////////////////////////////////////////////////////////////
void HtmlCalendarY(FILE *f, char *path, char *file, struct tm *tm, const char *yhref, const char *mhref) {
	struct stat sb; bzero(&sb, sizeof (struct stat));
	
	// years table
	fprintf(f, "<table border=1 cellpadding=3 cellspacing=0> \n");
	for (u_short yr=2000; yr<=tm->tm_year+1900; yr++) {
		snprintf(file, 255, yhref, yr);
		if (!stat(path, &sb)) {
			fprintf(f, "<tr><td bgcolor=silver><b>%d</b></td>\n", yr);
			for (int mon=1; mon<=12; mon++) {
				snprintf(file, 255, mhref, yr, mon);
				if (!stat(path, &sb)) {
					fprintf(f, "<td><a href=\"");
					fprintf(f, mhref, yr, mon);
					fprintf(f, "\">%s</a></td>", mon_name[mon-1]);
				} else
					fprintf(f, "<td>%s</td>", mon_name[mon-1]);
			}
			fprintf(f, "</tr>\n");
		}
	}
	fprintf(f, "</table>\n");
}

void HtmlCalendarM(FILE *f, char *path, char *file, struct tm *tm, const char *href) {
	struct stat sb; bzero(&sb, sizeof (struct stat));

	// month table
	fprintf(f, "<b>%s:</b><br>\n", Locale(LC_H_THIS_MONTH));
	for (u_char day=1; day<=31; day++){
		snprintf(file, 255, href, day);
		if (!stat(path, &sb)) {
			fprintf(f, "<a href=\"");
			fprintf(f, href, day);
			fprintf(f, "\">%d</a> ", day);
		} else
			fprintf(f, "%d ", day);
	}
	fprintf(f, "<br>\n");
}

void HtmlCalendarD(FILE *f, char *path, char *file, struct tm *tm, const char *href) {
	struct stat sb; bzero(&sb, sizeof (struct stat));

	// day table
	fprintf(f, "<b>%s:</b><br>\n", Locale(LC_H_THIS_DAY));
	for (u_char hour=0; hour<=11; hour++){
		snprintf(file, 255, href, hour);
		if (!stat(path, &sb)) {
			fprintf(f, "<a href=\"");
			fprintf(f, href, hour);
			fprintf(f, "\">%02d-%02d</a> ", hour, hour+1);
		} else
			fprintf(f, "%02d-%02d ", hour, hour+1);
	}
	
	fprintf(f, "<br>\n");
	
	for (u_char hour=12; hour<=23; hour++){
		snprintf(file, 255, href, hour);
		if (!stat(path, &sb)) {
			fprintf(f, "<a href=\"");
			fprintf(f, href, hour);
			fprintf(f, "\">%02d-%02d</a> ", hour, hour+1);
		} else
			fprintf(f, "%02d-%02d ", hour, hour+1);
	}
	fprintf(f, "<br></div>\n");
}
//////////////////////////////////////////////////////////////////////////////////////////
void HtmlRedirect(char *path, char *href) {
	FILE *f=fopen(path, "w");
        
	if(!f) {
		aLog(D_ERR, "Can't create file %s : %s\n", path, strerror(errno));
		return;
	}

	fprintf(f, "<html><HEAD><META http-equiv=\"Pragma\" content=\"no-cache\"><META http-equiv=\"Expires\" content=\"-1\"><META http-equiv=\"Cache-Control\" content=\"no-cache\"></HEAD><body><h1>Redirecting to this day index...</h1><script> \
		document.location.href=\"%s\"</script></body></html>\n", href);
	
	fclose(f);
}
//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
#ifdef HAVE_BILLING

void cShowBillingHtml(Html_cfg *cfg, Connection *conn){
	Service *s=Billing;
	if(!s) return;

	Account *ac;
//	Account *acx=NULL;
//	int isfull=0;
	char *blocked, *bcolor;

	fprintf(conn->stream_w, "<table cellpadding=3 cellspacing=0 border=1 width=95%% bgcolor=white>\n");
	fprintf(conn->stream_w, "<tr bgcolor=navy align=center><td valign=middle><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td><font face=monospace size=-1 color=yellow>%s</font></td> \
		<td><font face=monospace size=-1 color=yellow>%s</font></td></tr>\n", Locale(LC_H_B_ACNAME), Locale(LC_H_B_BALANCE), Locale(LC_H_B_STATUS), Locale(LC_H_B_PLAN), Locale(LC_H_B_UNITS));
	 
	for (ac=bAccounts->root; ac!=NULL; ac=ac->next){
		if (ac->status&ACCOUNT_DELETED) continue; //this account deleted
		if(ac->status&ACCOUNT_BLOCKED ) { blocked=Locale(LC_H_B_BLOCKED); bcolor="pink"; }
		else if (ac->status&ACCOUNT_BEBLOCKED) { blocked=Locale(LC_H_B_BEBLOCKED); bcolor="#ffffe0"; }
		else { blocked=Locale(LC_H_B_UNBLOCKED); bcolor="white"; }

		fprintf(conn->stream_w, "<tr><td><a href=\"../../../../accounts/%s/index.html\">%s</a></td><td align=center bgcolor=%s>%.4f</td><td align=center bgcolor=%s>%s</td><td>%s</td><td>&nbsp;", ac->name, ac->name, ac->balance>0?"white":"#ffffe0", ac->balance, bcolor, blocked, ac->plan?(ac->plan->name?ac->plan->name:"<\?\?>"):"-");
		for (bUlist *bu=ac->bUroot; bu!=NULL; bu=bu->next) {
			NetUnit *u=bu->u;
			if(cfg->cpages==CPAGES_ALL) 
				fprintf(conn->stream_w, "<a href=\"../../../../clients/%s/index.html\">%s</a> ", u->name?u->name:"<\?\?>", u->name?u->name:"-");
			else 
				fprintf(conn->stream_w, "%s", u->name?u->name:"<\?\?>");
		}
		fprintf(conn->stream_w, "</td></tr>\n");
	} // for
	fprintf(conn->stream_w, "</table>\n");
}
//////////////////////////////////////////////////////////////////////////////////////////
void cShowBillingAccountsHtml(Html_cfg *cfg, Connection *conn, struct tm *tm){
	Service *s=Billing;
	if(!s) return;
	ServiceStorage_cfg *st = (ServiceStorage_cfg*)((Billing_cfg*)s->cfg)->st->cfg;

	Account *ac;
	struct stat sb;
	bzero(&sb, sizeof (struct stat));
	char *blocked, *bcolor;

	u_char len=strlen(cfg->path);
	char path[512];			// better change then to dynamic allocation with len [len+256];
	strncpy(path, cfg->path, len);
	char *prefix=&path[len];        //prefix from cfg->path to actual filename
	char *file;                     //from here filename will be printed
	char tmp[256];

	for (ac=bAccounts->root; ac!=NULL; ac=ac->next){
		if (ac->status&ACCOUNT_DELETED) continue; //this account deleted
		if(ac->status&ACCOUNT_BLOCKED ) { blocked=Locale(LC_H_B_BLOCKED); bcolor="pink"; }
		else if (ac->status&ACCOUNT_BEBLOCKED) { blocked=Locale(LC_H_B_BEBLOCKED); bcolor="#ffffe0"; }
		else { blocked=Locale(LC_H_B_UNBLOCKED); bcolor="white"; }
		
		//create path
	
		snprintf(prefix, 255, "/accounts/%s/%04d/%02d", ac->name, tm->tm_year+1900, tm->tm_mon+1);
		if (sHSafeMkdir(path)) return;
		HTML_PUSHD(path);
		aDebug(DEBUG_HTML, "Creation account %s pages in %s\n", ac->name, path);

		// account current page
		snprintf(file, 255, "index-day-%02d.html", tm->tm_mday);
		conn=sHOpenFile(conn, path); if (!conn) return;
		sHPrintHeader(conn, Locale(LC_H_B_BALANCE_FOR), "javascript:history.go(-2)");

		fprintf(conn->stream_w, "<b>%s:</b> %s<br>\n", Locale(LC_H_B_ACNAME), ac->name);
		fprintf(conn->stream_w, "<b>%s:</b> %.4f (<small>%s</small>)<br>\n", Locale(LC_H_B_BALANCE), ac->balance, Locale(LC_H_TRAFINFO_ACTUAL));
		fprintf(conn->stream_w, "<b>%s:</b> <font style=\"background-color:%s\";>&nbsp;%s&nbsp;</font><br>\n", Locale(LC_H_B_STATUS), bcolor, blocked);
		fprintf(conn->stream_w, "<b>%s:</b> %s (<small>%s</small>)<br>\n", Locale(LC_H_B_PLAN), ac->plan?(ac->plan->name?ac->plan->name:"<\?\?>"):"-", ac->plan?(ac->plan->description?ac->plan->description:""):"");

		//++++++++++++++++++++++++++++++++++++++++++
		// year/month table (account)
		fprintf(conn->stream_w, "<br><b>%s:</b><br>", Locale(LC_H_CALENDAR));
		HtmlCalendarY(conn->stream_w, path, file, tm, "../../%04d", "../../%04d/%02d/index.html");

		// days table (account)
		HtmlCalendarM(conn->stream_w, path, file, tm, "index-day-%02d.html");
		//+++++++++++++++++++++++++++++++++++++++++

		fprintf(conn->stream_w, "<h3>%s %s, %s</h3>\n <div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_TRAFINFO_FOR), ac->name, Locale(LC_H_TRAFINFO_ACTUAL));

		sHPrintTHeader(conn->stream_w);
		for (bUlist *bu=ac->bUroot; bu!=NULL; bu=bu->next) {
			sHPrintUnitsTree(cfg, conn->stream_w, bu->u);
		}
		fprintf(conn->stream_w, "</table></div><br>");

		if (ac->plan) {
			billing_data *bd;
			Policy *p;
			static char b2qt[8][32];
			u_char poz=0;
			fprintf(conn->stream_w, "<h3>%s %s, %s</h3>\n <div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_PREINCLUDED_LEFT), ac->name, Locale(LC_H_TRAFINFO_ACTUAL));
			sHPrintTHeaderPreincluded(conn->stream_w);
			for(bSPlist *bsp=ac->plan->root;bsp!=NULL; bsp=bsp->next, poz++) {
				bd=&ac->data[poz];
				p = PolicyL->getPolicyById(bsp->sp->pid);
				if (!p || !p->name) break;
				fprintf(conn->stream_w, "<tr align=right><td bgcolor='#ffffcc'>%06X</td><td bgcolor='#ffffaa'>%s</td>",bsp->sp->id,p->name);
				if (bd->h.in<0 || bd->h.out<0) fprintf(conn->stream_w, "<td>%10s</td><td>%10s</td>", bytesQ2T(-bd->h.in, b2qt[0]), bytesQ2T(-bd->h.out, b2qt[1])); else fprintf(conn->stream_w, "<td>&nbsp;</td><td>&nbsp;</td>");
				if (bd->d.in<0 || bd->d.out<0) fprintf(conn->stream_w, "<td>%10s</td><td>%10s</td>", bytesQ2T(-bd->d.in, b2qt[2]), bytesQ2T(-bd->d.out, b2qt[3])); else fprintf(conn->stream_w, "<td>&nbsp;</td><td>&nbsp;</td>");
				if (bd->w.in<0 || bd->w.out<0) fprintf(conn->stream_w, "<td>%10s</td><td>%10s</td>", bytesQ2T(-bd->w.in, b2qt[4]), bytesQ2T(-bd->w.out, b2qt[5])); else fprintf(conn->stream_w, "<td>&nbsp;</td><td>&nbsp;</td>");
				if (bd->m.in<0 || bd->m.out<0) fprintf(conn->stream_w, "<td>%10s</td><td>%10s</td>", bytesQ2T(-bd->m.in, b2qt[6]), bytesQ2T(-bd->m.out, b2qt[7])); else fprintf(conn->stream_w, "<td>&nbsp;</td><td>&nbsp;</td>");
				fprintf(conn->stream_w, "</tr>\n");
			}
			fprintf(conn->stream_w, "</table></div><br>");
			fprintf(conn->stream_w, "</div><br>");
		}

		sPrintFooter(conn, "javascript:history.go(-2)");
		
		snprintf(file, 255, "index.html");
		conn=sHOpenFile(conn, path); if (!conn) return;
		sHPrintHeader(conn, Locale(LC_H_RUNTIME), "../../index.html");

		fprintf(conn->stream_w, "<h3>%s: %s</h3>\n <div style=\"margin-left : 5%%;\"> \n", Locale(LC_H_INDEX_MONTH), mon_name[tm->tm_mon]);

		//month table
		HtmlCalendarM(conn->stream_w, path, file, tm, "index-day-%02d.html");

		fprintf(conn->stream_w, "<br></div><br>\n");
		sPrintFooter(conn, "../../index.html");
		
		//change file and cleanup
		HTML_POPD();
		
		// create a master index file at account root, pointing to the current file
		snprintf(file, 255, "/accounts/%s/index.html", ac->name);
		snprintf(tmp, 255, "%04d/%02d/index-day-%02d.html", tm->tm_year+1900, tm->tm_mon+1, tm->tm_mday);
		HtmlRedirect(path, tmp);

		// check if .htaccess file should be created or changed
		// for billing accounts, ask for passwords in MySQL instead of local database or RADIUS
		snprintf(file, 255, "/accounts/%s/.htaccess", ac->name);
		if (cfg->is_htaccess && stat(path, &sb)) {
			snprintf(file, 255, "/accounts/%s/.htaccess", ac->name);
			conn=sHOpenFile(conn, path); if (!conn) return;
			fprintf(conn->stream_w, "AuthName \"NeTAMS Account Login\"\n Require user");
			Users->listUsersHtml(conn);
			fprintf(conn->stream_w, " %s\n<FilesMatch \"\\.(gif|jpe?g|png)$\">\nRequire valid-user\nSatisfy Any\n</FilesMatch>\nAuthType Basic\n\n", ac->name);
			if (cfg->is_htaccess==1) {
				fprintf(conn->stream_w, "AuthMySQLAuthoritative		on\n");
				fprintf(conn->stream_w, "AuthMySQLUser			%s\n", st->username?st->username:"root");
				if (st->password) fprintf(conn->stream_w, "AuthMySQLPassword		%s\n", st->password);
				fprintf(conn->stream_w, "AuthMySQLDB		%s\n", st->dbname?st->dbname:"netams");
				fprintf(conn->stream_w, "AuthMySQLHost		%s\n", st->hostname?st->hostname:"localhost");
				fprintf(conn->stream_w, "AuthMySQLUserTable		billing\n");
				fprintf(conn->stream_w, "AuthMySQLNameField		name\n");
				fprintf(conn->stream_w, "AuthMySQLPasswordField		passwd\n");
				fprintf(conn->stream_w, "AuthMySQLNoPasswd		off\n");
				fprintf(conn->stream_w, "AuthMySQLCryptedPasswords	off\n");
			}
			
		}

	} // loop for all accounts
}
#endif
//////////////////////////////////////////////////////////////////////////////////////////
