/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2005 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: lib.h,v 1.9.2.1 2006/06/01 04:15:02 anton Exp $ */

#ifndef __LIB_H
#define __LIB_H

#ifdef SOLARIS

int daemon(int nochdir, int noclose);
int vasprintf(char **ret, const char *format, va_list ap);
struct ether_addr *ether_aton(const char *a);
char *ether_ntoa(const struct ether_addr *n);
char *strcasestr(const char *s, const char *find);

#endif

/////////////////////////////////////////////////////////////////////////////////////////
//below obtained from flow-tools
#define FT_SO_RCV_BUFSIZE      (4*1024*1024) /* UDP recv socket buffer size */

int bigsockbuf(int fd, int dir, int size);
/////////////////////////////////////////////////////////////////////////////////////////
#define POLL_TIMEOUT	1000
#define SET_POLL(socket) struct pollfd pfd; pfd.fd=socket; pfd.events = POLLIN;
#define CHECK_POLL(status) { 									\
	if ((status = poll(&pfd, 1, POLL_TIMEOUT)) < 0 ) {					\
		if(errno != EINTR) aLog(D_ERR, "ds:%u poll: %s\n", cfg->id, strerror(errno));	\
		continue; 									\
	}										\
}

// from codeproject.com
#define ntohll(x) (((u_int64_t)(ntohl((u_int32_t)((x << 32) >> 32))) << 32) | \
                     (u_int32_t)ntohl(((u_int32_t)(x >> 32)))) //By Runner
#define htonll(x) ntohll(x)
///////////////////////////////////////////////////////////////////////////////////////// 

#endif
