/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2005 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: memory.h,v 1.12 2005/08/30 08:48:14 jura Exp $ */

/////////////////////////////////////////////////////////////////////////////////////////
// Memory management ////////////////////////////////////////////////////////////////////
#if defined(DEBUG) && defined(MEMORY_DEBUG)
void *aMalloc(char *file, unsigned line, size_t size);
void aFree(char *file, unsigned line, void *ptr);

#define aMalloc(size)	aMalloc(__FILE__, __LINE__, size)
#define aFree(ptr)	aFree(__FILE__, __LINE__, ptr)

#else
void *aMalloc(size_t size);
void aFree(void *ptr);
#endif

unsigned long long aGetBytesAllocated();
unsigned long aGetTimesAllocated();
unsigned long aGetTimesFreed();
unsigned aGetTimesFreedNull();

void aMemoryDebugInit();
void aMemoryDebugRelease();
void cShowDebugMemory(Connection *conn);
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
