/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2005 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: schema.h,v 1.4 2005/01/17 13:13:22 jura Exp $ */

/////////////////////////////////////////////////////////////////////////////////////////
// structures for internal schema entry and config entry representations
typedef struct schema_entry {
	oid skey;
	char *name;
	char *descriprtion;
	time_t created;
	time_t changed;
} schema_entry; 

typedef struct config_entry {
	oid skey;
	oid id;
	oid sequence;
	int i_val;
	char *s_val;
	time_t created;
	time_t changed;
	int optional;
} config_entry;
	
/////////////////////////////////////////////////////////////////////////////////////////
// This is a schema file for 'key-value' bindings at database configuration 
#define S_FALSE	0
#define S_TRUE	1
#define S_NETAMS_VERSION	2
#define S_CONFIG_VERSION	3
#define S_SERVICE_ON	4

// debug value
#define S_DEBUG	10

// scheduler 
#define S_SCHED_TIME	20
#define S_SCHED_ACTION	21

// server
#define S_SERVER_PORT	30
#define S_SERVER_LOGIN	31
#define S_SERVER_MAXCONN	32

// users - allowed to log into - NeTAMS admins
#define S_USR_LOGIN 40
#define S_USR_PASSWORD 41
#define S_USR_REALNAME 42
#define S_USR_EMAIL 43
#define S_USR_PERMIT 44

// processor
#define S_PROC_LOOKUPDELAY 50
#define S_PROC_FLOWLIFETIME 51
#define S_PROC_RESTRICT_ALL 52
#define S_PROC_RESTRICT_LOCAL 53
#define S_PROC_AA_IP 54
#define S_PROC_AA_MASK 55
#define S_PROC_AU_TYPE 56
#define S_PROC_AU_NAMING 57
#define S_PROC_AU_PREFIX 58
#define S_PROC_POLICY_NAME 60
#define S_PROC_POLICY_TGT 61
#define S_PROC_STORAGE 62
#define S_PROC_ACCESS_SCRIPT 63

#define S_UNIT_TYPE 70
#define S_UNIT_NAME 71
#define S_UNIT_IP 72
#define S_UNIT_MASK 73
#define S_UNIT_PARENT 74
#define S_UNIT_NLP 75
#define S_UNIT_AP 76
#define S_UNIT_FP 77
#define S_UNIT_SP 78
#define S_UNIT_EMAIL 79
#define S_UNIT_DSLIST 80
#define S_UNIT_AU 81
#define S_UNIT_BW 82

#define S_STORAGE_TYPE 90
#define S_STORAGE_PATH 91
#define S_STORAGE_USER 92
#define S_STORAGE_PASS 93
#define S_STORAGE_HOST 94
#define S_STORAGE_DBNAME 95
#define S_STORAGE_SOCKET 96
#define S_STORAGE_PORT 97

#define S_DS_TYPE 100
#define S_DS_SOURCE 101
#define S_DS_LISTEN 102
#define S_DS_CLOCK 103
#define S_DS_RULE 104

#define S_ALERTER_TYPE 110
#define S_ALERTER_SMTP 111

#define S_HTML_LANG 120
#define S_HTML_RUN 121
#define S_HTML_PATH 122
#define S_HTML_URL 123
#define S_HTML_SERVLETURL 124
#define S_HTML_HTACCESS 125
#define S_HTML_CLIENTPAGES 126
#define S_HTML_ACCOUNTPAGES 127

#define S_QUOTA_POLICY 130
#define S_QUOTA_SOFTTHRESH 131
#define S_QUOTA_DELAY 132
#define S_QUOTA_STORAGE 133
#define S_Q_E_XXX 1000 // quota entry type-XXX

#define S_LOGIN_XXX 140 // login entries XXX

#define S_MONITOR_TO 150 /* file | storage */
#define S_MONITOR_UNIT 151 

#define S_BILLING_XXX 160 // billing entries XXX



/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
