/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2005 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: sql_config.c,v 1.6 2005/08/23 15:45:43 jura Exp $ */

#include "netams.h"

/////////////////////////////////////////////////////////////////////////////////////////
int cSqlBoot(Connection *conn, char *filename) {

	// will search for the first storage service configured in that plain text config
	char *buffer=(char *)aMalloc(4*1024+1);
	FILE *file=fopen(filename, "rt");
	if (file==NULL) return -1;

	int ss_found=0;
	while (!feof(file)){
		fgets(buffer, 4*1024, file);
		if (ss_found==1) aCommand(conn, buffer);
		if (strncmp(buffer, "service storage", 15)==0) {
			aCommand(conn, buffer);
			ss_found=1;
		}
		if (buffer[0]==10) ss_found=0;
		bzero(buffer, 4*1024);
	}
	fclose(file);
	aFree(buffer);

	Service *s = Services->getServiceNextByType(SERVICE_STORAGE, NULL);
	if (s) {
		ServiceStorage_cfg *cfg = (ServiceStorage_cfg *)s->cfg;
		if (cfg->type==MY_SQL || cfg->type==POSTGRES || cfg->type==ORACLE) {
			aLog(D_INFO, "opening SQL configuration from database type %d\n", cfg->type);
		}
		else { 
			aLog(D_INFO, "configured storage is not SQL\n");
			return -1;
		}
	} 
	else {
		aLog(D_INFO, "no storages configured\n");
		return -2;
		}

	stConfigGetAll(s);

	return 1;
}
